// axios.js
import { useUserStore } from '../store/modules/user'
import axios from "axios";
const instance = axios.create({
  baseURL: "http://192.168.31.123:8080", // 设置基础 URL
  // baseURL:'',
  timeout: 1000, // 设置请求超时时间
});
instance.interceptors.request.use(
  (config: any) => {
    // 在发送请求之前做些什么，例如添加 token
    const token = useUserStore().userInfo.token;
    if (token) {
      config.headers['token'] = `${useUserStore().userInfo.token}`;
    }
    return config;
  },
  (error: any) => {
    return Promise.reject(error);
  }
);

instance.interceptors.response.use(
  (response: any) => {
    // 对响应数据做点什么
    return response.data;
  },
  (error: any) => {
    // 对响应错误做点什么
    return Promise.reject(error);
  }
);
export default instance;
