import { h, render, reactive, ref, defineEmits } from "vue";
import RightClickMenu from "./RightClickMenu.vue";
export default function useMenu(e: MouseEvent) {
  const contextMenuVisible = ref(true);
  const contextMenuTop = ref(0);
  const contextMenuLeft = ref(0);
  const contextMenuIndex = ref(0);
  const scope = document.body;
  let containerEl = reactive<HTMLElement | any>(null);
  let vnode = reactive<any>(null);
  let props = reactive<any>({});
  const setComponent = () => {
    props = {
      visible: contextMenuVisible.value,
      menuList: [
        "复制",
        "翻译",
        "设为客户名称",
        "设置国家/地区",
        "设为Email",
        "设为watchApp",
      ],
      active: contextMenuIndex.value,
      "onUpdate:info": (info: any) => {
        contextMenuIndex.value = info.index;
        setComponent();
      },
    };
    vnode = h(RightClickMenu, props);
    render(vnode, scope);
  };

  const openRightClickMenu = (e: MouseEvent) => {
    setComponent();
    containerEl = document.getElementById("select-box1");
    if (containerEl) containerEl.style.position = "fixed";
    if (containerEl) containerEl.style["z-index"] = "1000";
  };
  const showContextMenu = (event: any, item: any) => {
    //阻止默认右键事件
    event.preventDefault();
    //菜单可见
    contextMenuVisible.value = true;
    openRightClickMenu(e);
    //获取鼠标坐标
    contextMenuTop.value = event.clientY;
    contextMenuLeft.value = event.clientX;
    // 检测是否超出浏览器视口区域  一个菜单40px*6个
    const menuHeight = 300; // 右键菜单的高度
    const windowHeight = window.innerHeight;

    if (event.clientY + menuHeight > windowHeight) {
      // 如果右键菜单超出视口底部，调整位置为向上弹出
      contextMenuTop.value -= menuHeight;
    }
    containerEl.style.top = `${contextMenuTop.value}px`;
    containerEl.style.left = `${contextMenuLeft.value}px`;
    window.addEventListener("click", hideContextMenu);
  };
  //隐藏右键菜单的函数，移除点击事件监听器，并将 contextMenuVisible 设置为 false
  const hideContextMenu = (e: any) => {
    const pop: any = document.querySelector("#select-box1");
    if (!e || (e?.target && !pop.contains(e?.target))) {
      contextMenuVisible.value = false;
      setComponent();
      window.removeEventListener("click", hideContextMenu);
    }
  };
  return {
    contextMenuVisible,
    openRightClickMenu,
    showContextMenu,
    hideContextMenu,
  };
}
