import moment from "moment";
import { defineStore } from "pinia";
import { getUserList } from "@/axios/model/user";
export const useUserStore = defineStore("user", {
  state: () => {
    return {
      isConnected: false, //连接状态
      messages: [],
      customerInfo: {},
      count: 0,
      userInfo: {
        username: "admin",
        password: "",
        token: "",
      },
      userList: [],
    };
  },
  actions: {
    setCount(num: number) {
      this.count = num;
    },
    setCustomerInfo(res: any) {
      this.customerInfo = res;
    },
    setUserInfo(res: any) {
      this.userInfo = res;
    },
    setUserListMessages(res: any) {
      return new Promise((resolve, reject) => {
        const query = {
          code: this.userInfo.username,
        };
        getUserList(query).then(({ success, result, message }: any) => {
          if (success) {
            this.userList = result.map((item: any) => {
              return {
                ...item,
                username: item.id,
                userImg:"https://cdn.lirimall.com//lirigo/filetempImage/新鲜水果_1661668973048.png",
                messages: [],
              };
            });
            console.log(this.userList);
            resolve(result);
          }
        });
      });
    },
    connect() {
      // 连接成功后，将 isConnected 状态设置为 true
      this.isConnected = true;
    },
    disconnect() {
      // 断开连接或退出登录时，将 isConnected 状态设置为 false
      this.isConnected = false;
    },
  },
  persist: true,
});
